package com.qiqiim.webserver.user.controller;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.*;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.qiqiim.server.model.Session;
import com.qiqiim.webserver.user.dao.UserAdminInfoDao;
import com.qiqiim.webserver.user.model.*;
import com.qiqiim.webserver.user.service.*;
import org.apache.commons.lang.time.DateFormatUtils;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import com.alibaba.fastjson.JSONArray;
import com.qiqiim.constant.Constants;
import com.qiqiim.server.model.MessageWrapper;
import com.qiqiim.server.model.proto.MessageBodyProto;
import com.qiqiim.server.model.proto.MessageProto;
import com.qiqiim.server.proxy.MessageProxy;
import com.qiqiim.server.session.SessionManager;
import com.qiqiim.webserver.base.controller.BaseController;
import com.qiqiim.webserver.dwrmanage.DwrUtil;
import com.qiqiim.webserver.dwrmanage.connertor.DwrConnertor;
import com.qiqiim.webserver.sys.service.FilesInfoService;
import com.qiqiim.webserver.util.Pager;
import com.qiqiim.webserver.util.Query;

@Controller
public class ImController extends BaseController {
    @Autowired
    private SessionManager sessionManager;
    @Autowired
    private UserAccountService userAccountServiceImpl;
    @Autowired
    private UserDepartmentService userDepartmentServiceImpl;
    @Autowired
    private FilesInfoService filesInfoServiceImpl;
    @Autowired
    private UserMessageService userMessageServiceImpl;
    @Autowired
    private DwrConnertor dwrConnertorImpl;
    @Autowired
    private MessageProxy proxy;
    @Autowired
    private UserAdminInfoService userAdminInfoServiceImpl;
    @Autowired
    private UserInfoService userInfoServiceImpl;

    private static Logger logger = LoggerFactory.getLogger(ImController.class);

    /**
     * 列表
     */
    @RequestMapping("/consultantlist")
    public String consultantlist(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", userAccountServiceImpl.getAllConsultant(0l));
        String message = (String) getSession().getAttribute("message");
        if (message == null || "".equals(message)) {
            getSession().setAttribute("message", "");
        }
        return "user/consultantlist";
    }

    @RequestMapping("/conljtycsultant")
    public String consultantlist1(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", userAccountServiceImpl.getAllConsultant(1l));
        String message = (String) getSession().getAttribute("message");
        if (message == null || "".equals(message)) {
            getSession().setAttribute("message", "");
        }
        return "user/conljtycsultant";
    }

    @RequestMapping("/conljjlwsultant")
    public String consultantlist3(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", userAccountServiceImpl.getAllConsultant(3l));
        String message = (String) getSession().getAttribute("message");
        if (message == null || "".equals(message)) {
            getSession().setAttribute("message", "");
        }
        return "user/conljjlwsultant";
    }

    @RequestMapping("/conljjyfsultant")
    public String consultantlist4(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", userAccountServiceImpl.getAllConsultant(4l));
        String message = (String) getSession().getAttribute("message");
        if (message == null || "".equals(message)) {
            getSession().setAttribute("message", "");
        }
        return "user/conljjyfsultant";
    }

    /**
     * 单聊
     */
    @RequestMapping("/chat")
    public String chat(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", sessionManager.getSessions());
        return "chat";
    }

    /**
     * 群聊
     */
    @RequestMapping("/groupchat")
    public String group(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", sessionManager.getSessions());
        return "groupchat";
    }

    /**
     * 机器人
     */
    @RequestMapping("/bot")
    public String list(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        request.setAttribute("allsession", sessionManager.getSessions());
        return "bot";
    }

    /**
     * 登录IM
     */
    @RequestMapping("/login")
    public String login(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        Query query = new Query(params);
        UserAccountEntity userAccount = userAccountServiceImpl.validateUser(query);
        if (userAccount != null) {
            setLoginUser(userAccount);
            String template = check(request);
            if (template.equals(Constants.ViewTemplateConfig.mobiletemplate)) {
                return "layimmobile";
            }
            return "layim";
        }
        request.getSession().setAttribute("errorMessage", "用户名或密码错误");
        return "redirect:consultant.jsp";
    }

    @RequestMapping("/loginTest")
    @ResponseBody
    public String loginTest(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        Query query = new Query(params);
        UserAccountEntity userAccount = userAccountServiceImpl.validateUser(query);
        if (userAccount != null) {
            setLoginUser(userAccount);
            String template = check(request);
            if (template.equals(Constants.ViewTemplateConfig.mobiletemplate)) {
                return "登陆成功";
            }
            return "登陆成功";
        }
        return "用户名密码错误";
    }

    /**
     * 用户假装登录
     */
    @RequestMapping("/fakeLogin")
    public String fakeLogin(@RequestParam Map<String, Object> params, HttpServletRequest request) {
        //判断是否有用户已经登录
        String nowId = (String) params.get("nowId");
        if (nowId != null && !"".equals(nowId)) {
            UserAccountEntity userAccountEntity = userAccountServiceImpl.queryObject(Long.valueOf(nowId));
            params.put("account", userAccountEntity.getAccount());
            params.put("password", userAccountEntity.getPassword());
        }else{
            //生成新用户
            UserAccountEntity newUserAccount = new UserAccountEntity();
            String data = UUID.randomUUID().toString().replaceAll("-", "");
            newUserAccount.setAccount(data);
            newUserAccount.setPassword(data);
            UserInfoEntity userInfoEntity = new UserInfoEntity();
            userInfoEntity.setDeptid(2L);
            userInfoEntity.setName("游客");
            newUserAccount.setUserInfo(userInfoEntity);
            newUserAccount.setIsdel(0);
            userAccountServiceImpl.save(newUserAccount);
            //将信息放入params
            params.put("account", data);
            params.put("password", data);
        }



        //根据新用户登录
        Query query = new Query(params);
        UserAccountEntity userAccount = userAccountServiceImpl.validateUser(query);
        if (userAccount != null) {
            setLoginUser(userAccount);
            String template = check(request);
            String id = request.getParameter("wantedId");
            long wantedId = 0;
            if (id != null && !"".equals(id)) {
                wantedId = Long.parseLong(id);
            }
            request.getSession().setAttribute("wantedId", wantedId);
            if (template.equals(Constants.ViewTemplateConfig.mobiletemplate)) {
                return "layimmobile";
            }
            return "layim";
        }
        return "redirect:consultant.jsp";
    }


    /**
     * 取得所有聊天用户
     *
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/getusers", produces = "text/html;charset=UTF-8")
    @ResponseBody
    public Object getAllUser(HttpServletResponse response, HttpServletRequest request,
                             RedirectAttributes redirectAttributes) throws Exception {
        // 数据格式请参考文档  http://www.layui.com/doc/modules/layim.html
        if (getLoginUser() != null) {

            UserInfoEntity user = getLoginUser().getUserInfo();
            ImFriendUserInfoData my = new ImFriendUserInfoData();
            my.setId(user.getUid());
            my.setAvatar(user.getProfilephoto());
            my.setSign(user.getSignature());
            my.setUsername(user.getName());
            my.setStatus("online");

            //模拟群信息
            ImGroupUserData group = new ImGroupUserData();
            group.setAvatar("http://tva2.sinaimg.cn/crop.0.0.199.199.180/005Zseqhjw1eplix1brxxj305k05kjrf.jpg");
            group.setId(1L);
            group.setGroupname("公司群");
            List<ImGroupUserData> groups = new ArrayList<ImGroupUserData>();
            groups.add(group);

            Map map = new HashMap();
            ImUserData us = new ImUserData();
            us.setCode("0");
            us.setMsg("");
            map.put("mine", my);
//				map.put("group",groups);
            //获取用户分组 及用户
            List<ImFriendUserData> friends = new ArrayList<>();
            //管理员列表即为与其有过聊天记录的用户
            if (user.getDeptid() != 2) {
                friends = userDepartmentServiceImpl.adminsQueryGroupAndUser(user.getUid());
            } else {
                Long l = (Long) request.getSession().getAttribute("wantedId");
                if (l == null) {
                    l = 0L;
                }
                friends = userDepartmentServiceImpl.usersQueryGroupAndUser(l);
            }
            map.put("friend", friends);
            us.setData(map);
            return JSONArray.toJSON(us);
        } else {
            return JSONArray.toJSON("");
        }
    }

    @RequestMapping(value = "/getusers2", produces = "text/html;charset=UTF-8")
    @ResponseBody
    public Object getAllUser2(HttpServletResponse response, HttpServletRequest request,
                              RedirectAttributes redirectAttributes) throws Exception {
        // 数据格式请参考文档  http://www.layui.com/doc/modules/layim.html
        if (getLoginUser() != null) {
            Long mineId = Long.valueOf(request.getParameter("mineId"));
            long deptId = userAccountServiceImpl.getUserDept(mineId);
            if (deptId == 2L) {
                return JSONArray.toJSON("");
            }
            UserInfoEntity user = getLoginUser().getUserInfo();
            ImFriendUserInfoData my = new ImFriendUserInfoData();
            my.setId(user.getUid());
            my.setAvatar(user.getProfilephoto());
            my.setSign(user.getSignature());
            my.setUsername(user.getName());
            my.setStatus("online");

            //模拟群信息
            ImGroupUserData group = new ImGroupUserData();
            group.setAvatar("http://tva2.sinaimg.cn/crop.0.0.199.199.180/005Zseqhjw1eplix1brxxj305k05kjrf.jpg");
            group.setId(1L);
            group.setGroupname("公司群");
            List<ImGroupUserData> groups = new ArrayList<ImGroupUserData>();
            groups.add(group);

            Map map = new HashMap();
            ImUserData us = new ImUserData();
            us.setCode("0");
            us.setMsg("");
            map.put("mine", my);
            map.put("deptId", deptId);
            //获取用户分组 及用户
            List<ImFriendUserData> friends = new ArrayList<>();
            //管理员查看所有人员信息
            List<ImFriendUserData> list = userDepartmentServiceImpl.adminsQueryGroupAndUser(mineId);
            String allId = "";
            for (ImFriendUserInfoData imFriendUserInfoData : list.get(0).getList()) {
                if (list.get(0).getList().indexOf(imFriendUserInfoData) == list.get(0).getList().size() - 1) {
                    allId += "uid != " + imFriendUserInfoData.getId();
                } else {
                    allId += "uid != " + imFriendUserInfoData.getId() + " and ";
                }
            }
            if (list.get(0).getList().size() == 0) {
                list.get(0).setList(userDepartmentServiceImpl.adminsQueryGroupAndUser2(allId).get(0).getList());
            } else {
                list.get(0).getList().addAll(userDepartmentServiceImpl.adminsQueryGroupAndUser2(allId).get(0).getList());
            }
            map.put("friend", list);
            us.setData(map);
            return JSONArray.toJSON(us);
        } else {
            return JSONArray.toJSON("");
        }
    }


    /**
     * 图片上传
     *
     * @param file
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/imgupload", produces = "text/html;charset=UTF-8", method = RequestMethod.POST)
    @ResponseBody
    public Object uploadImgFile(@RequestParam MultipartFile file,
                                HttpServletResponse response, HttpServletRequest request,
                                RedirectAttributes redirectAttributes) throws Exception {

        UserAccountEntity u = getLoginUser();
        Long uid = u.getId();
//        String path = request.getSession().getServletContext().getRealPath("upload/img/temp/");
        String path = request.getSession().getServletContext().getRealPath("/upload/img/temp/");
        String files = filesInfoServiceImpl.savePicture(file, uid.toString() + UUID.randomUUID().toString(), path);
        Map<String, Object> map = new HashMap<String, Object>();
        Map<String, String> submap = new HashMap<String, String>();
        if (files.length() > 0) {
            map.put("code", "0");
            map.put("msg", "上传过成功");
            submap.put("src", request.getContextPath() + "/upload/img/temp/" + files + "?" + new Date().getTime());
        } else {
            submap.put("src", "");
            map.put("code", "1");
            map.put("msg", "上传过程中出现错误，请重新上传");
        }
        map.put("data", submap);
        return JSONArray.toJSON(map);
    }


    /**
     * 文件上传
     *
     * @param file
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/fileupload", produces = "text/html;charset=UTF-8", method = RequestMethod.POST)
    @ResponseBody
    public Object uploadAllFile(@RequestParam MultipartFile file,
                                HttpServletResponse response, HttpServletRequest request,
                                RedirectAttributes redirectAttributes) throws Exception {

        UserAccountEntity u = getLoginUser();
        Long uid = u.getId();
        String path = request.getSession().getServletContext().getRealPath("upload/file/temp/");
        String files = filesInfoServiceImpl.saveFiles(file, uid.toString() + UUID.randomUUID().toString(), path);
        Map<String, Object> map = new HashMap<String, Object>();
        Map<String, String> submap = new HashMap<String, String>();
        if (files.length() > 0) {
            map.put("code", "0");
            map.put("msg", "上传过成功");
            submap.put("src", request.getContextPath() + "/upload/file/temp/" + files + "?" + new Date().getTime());
            submap.put("name", file.getOriginalFilename());
        } else {
            submap.put("src", "");
            map.put("code", "1");
            map.put("msg", "上传过程中出现错误，请重新上传");
        }
        map.put("data", submap);
        return JSONArray.toJSON(map);
    }

    /**
     * 模拟最新系统消息
     *
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/message", method = RequestMethod.GET)
    public String userMessage(HttpServletResponse response, HttpServletRequest request,
                              RedirectAttributes redirectAttributes) throws Exception {

        List<UserMessageEntity> list = new ArrayList<UserMessageEntity>();
        UserMessageEntity msg = new UserMessageEntity();
        msg.setContent("模拟系统消息");
        msg.setCreatedate(DateFormatUtils.format(new Date(), "yyyy-MM-dd HH:mm:ss"));
        list.add(msg);
        UserMessageEntity msgTwo = new UserMessageEntity();
        msgTwo.setContent("模拟系统消息1");
        msgTwo.setCreatedate(DateFormatUtils.format(new Date(), "yyyy-MM-dd HH:mm:ss"));
        list.add(msgTwo);
        request.setAttribute("msgList", list);
        return "message";
    }

    /**
     * 取得离线消息
     *
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/getofflinemsg", produces = "text/html;charset=UTF-8", method = RequestMethod.POST)
    @ResponseBody
    public Object userMessageCount(HttpServletResponse response, HttpServletRequest request,
                                   RedirectAttributes redirectAttributes) throws Exception {
        Map<String, Object> map = new HashMap<String, Object>();
        if (getLoginUser() != null) {
            map.put("receiveuser", getLoginUser().getId().toString());
        } else {
            map.put("receiveuser", request.getSession().getId());
        }
        List<UserMessageEntity> list = userMessageServiceImpl.getOfflineMessageList(map);
        return JSONArray.toJSON(list);
    }

    /**
     * 聊天记录
     *
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/historymessageajax", produces = "text/html;charset=UTF-8", method = RequestMethod.POST)
    @ResponseBody
    public Object userHistoryMessages(HttpServletResponse response, HttpServletRequest request,
                                      RedirectAttributes redirectAttributes) throws Exception {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("page", getSkipToPage());
        map.put("limit", getPageSize());
        map.put("senduser", getLoginUser().getId());
        map.put("receiveuser", Long.parseLong(request.getParameter("id")));
        List<UserMessageEntity> list = userMessageServiceImpl.getHistoryMessageList(new Query(map));
        Map<String, List<UserMessageEntity>> resultMap = new HashMap();
        resultMap.put("data", list);
        return JSONArray.toJSON(resultMap);
    }

    /**
     * 聊天记录页面
     *
     * @param response
     * @param request
     * @param redirectAttributes
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/historymessage", method = RequestMethod.GET)
    public String userHistoryMessagesPage(HttpServletResponse response, HttpServletRequest request,
                                          RedirectAttributes redirectAttributes) throws Exception {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("senduser", getLoginUser().getId());
        map.put("receiveuser", Long.parseLong(request.getParameter("id")));
        int totalsize = userMessageServiceImpl.getHistoryMessageCount(map);
        Pager pager = new Pager(getSkipToPage(), getPageSize(), totalsize);
        request.setAttribute("pager", pager);
        return "/historymessage";
    }


    @RequestMapping(value = "/sendmsg", method = RequestMethod.GET)
    @ResponseBody
    public Object sendMsg(HttpServletResponse response, HttpServletRequest request,
                          RedirectAttributes redirectAttributes) throws Exception {
        String sessionid = request.getSession().getId();
        if (getLoginUser() != null) {
            sessionid = getLoginUser().getId().toString();
        }
        MessageProto.Model.Builder builder = MessageProto.Model.newBuilder();
        builder.setCmd(Constants.CmdType.MESSAGE);
        builder.setSender(sessionid);
        builder.setReceiver((String) request.getParameter("receiver"));
        builder.setMsgtype(Constants.ProtobufType.REPLY);
        MessageBodyProto.MessageBody.Builder msg = MessageBodyProto.MessageBody.newBuilder();
        msg.setContent((String) request.getParameter("content"));
        builder.setContent(msg.build().toByteString());
        MessageWrapper wrapper = proxy.convertToMessageWrapper(sessionid, builder.build());
        dwrConnertorImpl.pushMessage(sessionid, wrapper);
        return JSONArray.toJSON("");
    }

    @RequestMapping(value = "/Main")
    @ResponseBody
    public Object getOnlineAdmins(HttpServletResponse response, HttpServletRequest request,
                                  RedirectAttributes redirectAttributes) {
        String deptId = request.getParameter("deptId");
//        if(deptId != null && !"".equals(deptId)){
//            deptId = "deptid = " + deptId;
//        }else{
//            deptId = "deptid != 2";
//        }
        if (deptId != null && !"".equals(deptId)) {
            if ("路劲太阳城".equals(deptId)) {
                deptId = "deptid = 1";
            } else if ("路劲隽澜湾".equals(deptId)) {
                deptId = "deptid = 3";
            } else if ("隽悦府".equals(deptId)) {
                deptId = "deptid = 4";
            } else {
                deptId = "deptid != 2";
            }
        } else {
            deptId = "deptid != 2";
        }
        List<Long> allAdminId = userInfoServiceImpl.getAllAdminId(deptId);
        Session[] sessions = sessionManager.getSessions();
        List<Session> list = Arrays.asList(sessions);
        List<UserAdminInfoEntity> resultList = userAdminInfoServiceImpl.sortOnlineAdmin(allAdminId);
        List<UserAdminInfoEntity> onlineList = new ArrayList<>();
        List<UserAdminInfoEntity> offlineList = new ArrayList<>();
        loop1:
        for (UserAdminInfoEntity userAdminInfoEntity : resultList) {
            if (userAdminInfoEntity.getRemark() == null) {
                userAdminInfoEntity.setRemark("");
            }
            for (Session session : sessions) {
                if (Long.valueOf(session.getAccount()) == userAdminInfoEntity.getUid()) {
                    userAdminInfoEntity.setOnline(true);
                    onlineList.add(userAdminInfoEntity);
                    continue loop1;
                }
            }
            offlineList.add(userAdminInfoEntity);
        }
        //将在线客服排在非在线之前
        onlineList.addAll(offlineList);
        return onlineList;
    }


    /**
     * 头像上传
     *
     * @param file
     * @param response
     * @param request
     * @param redirectAttributes
     * @param uid
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "/headpicupload", produces = "multipart/form-data", method = RequestMethod.POST)
    @ResponseBody
    public ModelAndView uploadHeadPic(@RequestParam MultipartFile file,
                                      HttpServletResponse response, HttpServletRequest request,
                                      RedirectAttributes redirectAttributes, @Param(value = "fileName") Long uid,
                                      @Param(value = "whereToGo") String whereToGo) throws Exception {

        String fileName = uid + "hp";
        String path = request.getSession().getServletContext().getRealPath("/layui/images/headpic/");
        String files = filesInfoServiceImpl.saveHeadPic(file, fileName, path);
        Map<String, Object> map = new HashMap<String, Object>();
        Map<String, String> submap = new HashMap<String, String>();
        if (whereToGo == null) {
            whereToGo = "";
        }
        getSession().setAttribute("message", "上传成功");
        if (files.length() > 0) {
            userInfoServiceImpl.updateHeadPic("layui/images/headpic/" + files, uid);
            if (whereToGo.equals("1")) {
                return new ModelAndView("redirect:/conljtycsultant");
            } else if (whereToGo.equals("3")) {
                return new ModelAndView("redirect:/conljjlwsultant");
            } else if (whereToGo.equals("4")) {
                return new ModelAndView("redirect:/conljjyfsultant");
            } else {
                return new ModelAndView("redirect:/consultantlist");
            }
        }
        if (whereToGo.equals("1")) {
            return new ModelAndView("redirect:/conljtycsultant");
        } else if (whereToGo.equals("3")) {
            return new ModelAndView("redirect:/conljjlwsultant");
        } else if (whereToGo.equals("4")) {
            return new ModelAndView("redirect:/conljjyfsultant");
        } else {
            return new ModelAndView("redirect:/consultantlist");
        }
    }


    @RequestMapping(value = "/updateConsultantDetail", produces = "text/html;charset=UTF-8", method = RequestMethod.POST)
    public ModelAndView updateConsultantDetail(ConsultantManagerEntity consultantManagerEntity) throws Exception {
        userAccountServiceImpl.updateDetail(consultantManagerEntity);
        getSession().setAttribute("message", "修改成功");
        if (consultantManagerEntity.getWhereToGo() == null) {
            consultantManagerEntity.setWhereToGo("");
        }
        if (consultantManagerEntity.getWhereToGo().equals("1")) {
            return new ModelAndView("redirect:/conljtycsultant");
        } else if (consultantManagerEntity.getWhereToGo().equals("3")) {
            return new ModelAndView("redirect:/conljjlwsultant");
        } else if (consultantManagerEntity.getWhereToGo().equals("4")) {
            return new ModelAndView("redirect:/conljjyfsultant");
        } else {
            return new ModelAndView("redirect:/consultantlist");
        }
    }

    @RequestMapping(value = "/addConsultant", method = RequestMethod.POST)
    public ModelAndView addConsultant(@Param(value = "whereToGo") String whereToGo,
                                      @Param(value = "account") String account,
                                      @Param(value = "password") String password,
                                      @Param(value = "phone") String phone,
                                      @Param(value = "deptid") Long deptid,
                                      @Param(value = "name") String name,
                                      @Param(value = "remark") String remark) throws UnsupportedEncodingException {
        if (whereToGo == null) {
            whereToGo = "";
        }
        UserAccountEntity userAccountEntity = new UserAccountEntity();
        userAccountEntity.setAccount(new String(account.getBytes("iso8859-1"), "UTF-8"));
        userAccountEntity.setPassword(new String(password.getBytes("iso8859-1"), "UTF-8"));
        UserInfoEntity userInfoEntity = new UserInfoEntity();
        userInfoEntity.setDeptid(deptid);
        userInfoEntity.setName(new String(name.getBytes("iso8859-1"), "UTF-8"));
        userInfoEntity.setPhone(new String(phone.getBytes("iso8859-1"), "UTF-8"));
        userInfoEntity.setRemark(new String(remark.getBytes("iso8859-1"), "UTF-8"));
        userAccountEntity.setUserInfo(userInfoEntity);
        int flag = userAccountServiceImpl.save(userAccountEntity);
        if (flag == 1) {
            getSession().setAttribute("message", "添加成功");
        } else {
            getSession().setAttribute("message", "添加失败,用户名重复");
        }
        if (whereToGo.equals("1")) {
            return new ModelAndView("redirect:/conljtycsultant");
        } else if (whereToGo.equals("3")) {
            return new ModelAndView("redirect:/conljjlwsultant");
        } else if (whereToGo.equals("4")) {
            return new ModelAndView("redirect:/conljjyfsultant");
        } else {
            return new ModelAndView("redirect:/consultantlist");
        }


    }

    @RequestMapping(value = "/delConsultant", method = RequestMethod.POST)
    public ModelAndView delConsultant(@Param(value = "whereToGo") String whereToGo,
                                      @Param(value = "id") long id) {

        userAdminInfoServiceImpl.delByUid(id);
        userInfoServiceImpl.delByUid(id);
        userAccountServiceImpl.delete(id);
        getSession().setAttribute("message", "删除成功");
        if (whereToGo == null) {
            whereToGo = "";
        }
        if (whereToGo.equals("1")) {
            return new ModelAndView("redirect:/conljtycsultant");
        } else if (whereToGo.equals("3")) {
            return new ModelAndView("redirect:/conljjlwsultant");
        } else if (whereToGo.equals("4")) {
            return new ModelAndView("redirect:/conljjyfsultant");
        } else {
            return new ModelAndView("redirect:/consultantlist");
        }
    }

    @RequestMapping(value = "/receivePhone")
    @ResponseBody
    public Map<String,Object> receivePhone(@Param(value = "id") long id){
        String phone = userInfoServiceImpl.getPhone(id);
        Map<String,Object> map = new HashMap<>();
        map.put("phone", phone);
        return map;
    }
}



