package com.qiqiim.webserver.user.dao;
import java.util.List;
import java.util.Map;

import com.qiqiim.webserver.base.dao.BaseDao;
import com.qiqiim.webserver.user.model.ConsultantManagerEntity;
import com.qiqiim.webserver.user.model.UserAccountEntity;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;


public interface UserAccountDao extends BaseDao<UserAccountEntity> {
	public UserAccountEntity queryObjectByAccount(Map<String, Object> map);

	public long getUserDept(Long userId);

	public List getAllLongTimeUserId();

	public int deleteLongTimeUser(List<Long> list);

	public List<ConsultantManagerEntity> getAllConsultant(@Param(value = "tiaojian") String tiaojian);

	public int updateConsultantDept(@Param(value = "deptName") String deptName, @Param(value = "id") long id);

	public int updateConsultantPassword(@Param(value = "password") String password, @Param(value = "id") long id);

	public int updateConsultantRemark(@Param(value = "remark") String remark, @Param(value = "id") long id);

	public int updateConsultantPhone(@Param(value = "phone") String phone, @Param(value = "id") long id);

	public int updateConsultantName(@Param(value = "name") String name, @Param(value = "id") long id);

	public int updateConsultantMessagePhone(@Param(value = "messagePhone") String messagePhone, @Param(value = "id") long id);

	@Update(
            "<script>" +
                    "update user_info,user_account set " +
                    "<if test=\"deptName !=null and deptName != '' \">user_info.deptid = #{deptName}, </if> " +
                    "<if test=\"password !=null and password != '' \">user_account.password = #{password}, </if> " +
                    "<if test=\"remark !=null and remark != '' \">user_info.remark = #{remark}, </if> " +
                    "<if test=\"phone !=null and phone != '' \">user_info.phone = #{phone}, </if> " +
                    "<if test=\"name !=null and name != '' \">user_info.name = #{name}, </if> " +
                    "<if test=\"messagePhone !=null and messagePhone != '' \">user_info.message_phone = #{messagePhone}, </if> " +
                    "user_info.uid = #{id} " +
                    "where user_info.uid = #{id} and user_info.uid = user_account.id" +
                    "</script>"
    )
	public int updateConsultant(ConsultantManagerEntity consultantManagerEntity);
}
