package com.qiqiim.webserver.user.service.impl;

import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.qiqiim.webserver.user.model.ConsultantManagerEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.qiqiim.webserver.user.dao.UserAccountDao;
import com.qiqiim.webserver.user.model.UserAccountEntity;
import com.qiqiim.webserver.user.model.UserInfoEntity;
import com.qiqiim.webserver.user.service.UserAccountService;
import com.qiqiim.webserver.user.service.UserInfoService;


@Service("userAccountServiceImpl")
public class UserAccountServiceImpl implements UserAccountService {
    @Autowired
    private UserAccountDao userAccountDao;
    @Autowired
    private UserInfoService userInfoServiceImpl;
    @Autowired
    private UserAdminInfoServiceImpl userAdminInfoService;

    @Override
    public UserAccountEntity queryObject(Long id) {
        return userAccountDao.queryObject(id);
    }

    @Override
    public List<UserAccountEntity> queryList(Map<String, Object> map) {
        return userAccountDao.queryList(map);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        return userAccountDao.queryTotal(map);
    }

    @Override
    public int save(UserAccountEntity userAccount) {
        //判断用户是否已注册
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("account", userAccount.getAccount());
        UserAccountEntity user = queryObjectByAccount(map);
        if (user == null || user.getId() < 1) {
            userAccountDao.save(userAccount);
            if (userAccount != null && userAccount.getId() != null) {
                //保存基本信息
                UserInfoEntity userInfo = userAccount.getUserInfo();
                userInfo.setUid(userAccount.getId());
                userInfoServiceImpl.save(userInfo);
                if (userAccount.getUserInfo().getDeptid() != 2) {
                    userAdminInfoService.save(userAccount.getId());
                }
                return 1;
            }
        }
        return 0;
    }

    @Override
    public int update(UserAccountEntity userAccount) {
        return userAccountDao.update(userAccount);
    }

    @Override
    public int delete(Long id) {
        return userAccountDao.delete(id);
    }

    @Override
    public int deleteBatch(Long[] ids) {
        return userAccountDao.deleteBatch(ids);
    }

    @Override
    public long getUserDept(long deptId) {
        return userAccountDao.getUserDept(deptId);
    }

    @Override
    public List<ConsultantManagerEntity> getAllConsultant(Long deptId) {
        String tiaojian = "";
        if (deptId == 1L) {
            tiaojian = " deptid = 1";
        } else if (deptId == 3L) {
            tiaojian = " deptid = 3";
        } else if (deptId == 4L) {
            tiaojian = " deptid = 4";
        } else {
            tiaojian = " deptid != 2";
        }
        return userAccountDao.getAllConsultant(tiaojian);
    }

    @Override
    public int updateDetail(ConsultantManagerEntity consultantManagerEntity) throws UnsupportedEncodingException {
        int i = 0;
        consultantManagerEntity.setName(new String(consultantManagerEntity.getName().getBytes("iso8859-1"), "UTF-8"));
//		if(consultantManagerEntity.getDeptName() != null && !"".equals(consultantManagerEntity.getDeptName())){
//            i += userAccountDao.updateConsultantDept( new String (consultantManagerEntity.getDeptName().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
//		if (consultantManagerEntity.getPassword() != null && !"".equals(consultantManagerEntity.getPassword())){
//			i += userAccountDao.updateConsultantPassword( new String (consultantManagerEntity.getPassword().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
//		if(consultantManagerEntity.getName() != null && !"".equals(consultantManagerEntity.getName())){
//            i += userAccountDao.updateConsultantName( new String (consultantManagerEntity.getName().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
//		if(consultantManagerEntity.getPhone() != null){
//            i += userAccountDao.updateConsultantPhone( new String (consultantManagerEntity.getPhone().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
//		if(consultantManagerEntity.getRemark() != null){
//			i += userAccountDao.updateConsultantRemark( new String (consultantManagerEntity.getRemark().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
//		if(consultantManagerEntity.getMessagePhone() != null){
//			i += userAccountDao.updateConsultantMessagePhone( new String (consultantManagerEntity.getMessagePhone().getBytes("iso8859-1"),"UTF-8"), Long.parseLong(consultantManagerEntity.getId()));
//		}
        i = userAccountDao.updateConsultant(consultantManagerEntity);
        return i;
    }

    @Override
    public UserAccountEntity queryObjectByAccount(Map<String, Object> map) {
        return userAccountDao.queryObjectByAccount(map);
    }

    @Override
    public UserAccountEntity validateUser(Map<String, Object> map) {
        UserAccountEntity user = queryObjectByAccount(map);
        if (user != null) {
            String password = (String) map.get("password");
            if (password.equals(user.getPassword())) {
                return user;
            }
        }
        return null;
    }


}
