<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8" %>
<%@ include file="/WEB-INF/page/public/taglib.jsp" %>
<!doctype html>
<html>
<head>
    <title>错误查看</title>
    <link href="img/icon.ico" rel="SHORTCUT ICON"/>
    <%@ include file="/WEB-INF/page/public/meta.jsp" %>
    <link rel="stylesheet" href="layui/css/layui.css">
</head>
<body>
<div style="margin: 20px;">

    <div id="list">
        <table class="layui-table" lay-size="lg">
            <colgroup>
                <col width="150">
                <col width="200">
                <col>
            </colgroup>
            <thead>
            <tr>
                <th>错误ID</th>
                <th>用户ID</th>
                <th>顾问ID</th>
                <th>接受者电话</th>
                <th>发送信息</th>
                <th>错误代码</th>
                <th>错误信息</th>
                <th>发送时间</th>
                <th>操作</th>
            </tr>
            </thead>
            <tbody>
            <c:forEach items="${allsession}" var="user">
                <tr>
                    <td>${user.id}</td>
                    <td>${user.userId}</td>
                    <td>${user.consultantId}</td>
                    <td>${user.phone}</td>
                    <td>${user.message}</td>
                    <td>${user.errorCode}</td>
                    <td>${user.errorMessage}</td>
                    <td>${user.sendTime}</td>
                    <td>
                        <a class="layui-btn layui-btn-primary layui-btn-xs sendUserMsg" onclick="del(this)">删除</a>
                    </td>
                </tr>
            </c:forEach>
            </tbody>
        </table>
    </div>

    <div id="delDiv" style="display: none">
        <fieldset class="layui-elem-field index-button" style="margin-top: 30px">
            <legend>添加</legend>
            <div>
                <form class="layui-form" action="delError" method="post" id="delForm">
                    <input name="id" id="id3" type="text" style="display: none"/>
                    <div class="layui-form-item">
                        <label class="layui-form-label">描述</label>
                        <div class="layui-input-block">
                            <input type="text" name="solution" placeholder="输入解决方案"
                                   autocomplete="off" class="layui-input">
                        </div>
                    </div>
                    <div class="layui-form-item">
                        <div class="layui-input-block">
                            <button id="regBut" class="layui-btn" onclick="subdel()">添加</button>
                            <a class="layui-btn layui-btn-primary" onclick="cancel()" target="_blank">返回
                            </a>
                        </div>
                    </div>
                </form>
            </div>
        </fieldset>
    </div>

    <script src="layui/layui.js"></script>
</div>

<script>
    var form;
    layui.use('form', function () {
        form = layui.form;

    });

    function del(e) {
        document.getElementById("id3").value = e.parentElement.parentElement.children[0].innerHTML;
        document.getElementById("list").style.display = 'none';
        document.getElementById("delDiv").style.display = 'block';
    }

    function subdel(){
        document.getElementById("delForm").submit();
    }

    window.onload = function(){
        var message = "";
        message = "${sessionScope.message}";
        if(message == null || message === ""){
            return;
        }
        alert(message);
        ${sessionScope.remove("message")}
    }
</script>
</body>
</html>